Subject: [v6ops] RFC7084 - WPD-4

From: Wuyts Carl <[email-masked]>
Date: Tue, 10 Dec 2013 10:59:47 +0000

So,

Although I did not plan to send another mail on these reqs, I've got a question on the below, as I'm fully lost now I'm afraid.

WPD-4 By default, the IPv6 CE router MUST initiate DHCPv6 prefix delegation when either the M or O flags are set to 1 in a received Router Advertisement (RA) message.  Behavior of the
           CE router to use DHCPv6 prefix delegation when the CE router has not received any RA or received an RA with the M and the O bits set to zero is out of scope for this document.

If I read this, this req says: "do stateful dhcpv6 (ia_pd) in case of M-flag=1 OR O-flag=1 in the received RA".
Right or not ???

If this statement is correct, I'm totally lost.  According to what I read in RFC4861 and 3315.  O=1 means "other configuration" means "information-request" DHCPv6 messages i.s.o. solicit, meaning not (allowed) to add stateful options (IA_INA/IA_PD options) ???
Moreover, extract from RFC3633:
""
A requesting router first creates an IA_PD and assigns it an IAID.
   The requesting router then transmits a Solicit message containing an
   IA_PD option describing the IA_PD.  Delegating routers that can
   delegate prefixes to the IA_PD respond to the requesting router with
   an Advertise message.

""

summary:

Other Stateful Configuration Flag , which is also known as the O flag.
When set to 1, this flag instructs the host to use a configuration protocol to obtain other configuration settings.
Combining the values of the M and O flags can yield the following:

Both M and O Flags are Set to 0. This combination corresponds to a network without a DHCPv6 infrastructure.
Hosts use router advertisements for non-link-local addresses and other methods (such as manual configuration) to configure other settings.

Both M and O Flags are Set to 1. DHCPv6 is used for both addresses and other configuration settings.
This combination is known as DHCPv6 stateful, in which DHCPv6 is assigning stateful addresses to IPv6 hosts.

The M Flag is Set to 0 and the O Flag is Set to 1. DHCPv6 is not used to assign addresses, only to assign other configuration settings.
Neighboring routers are configured to advertise non-link-local address prefixes from which IPv6 hosts derive stateless addresses. This combination is known as
DHCPv6 stateless: DHCPv6 is not assigning stateful addresses to IPv6 hosts, but stateless configuration settings.

The M Flag is Set to 1 and the O Flag is Set to 0. In this combination, DHCPv6 is used for address configuration but not for other settings. Because IPv6 hosts typically need to be configured with other settings, such as the IPv6 addresses of Domain Name System (DNS) servers, this is an unlikely combination.

Regs
Carl

---

From: Sander Steffann <[email-masked]>
Date: Tue, 10 Dec 2013 12:22:46 +0100

Hi,

Op 10 dec. 2013, om 11:59 heeft Wuyts Carl <[email-masked]> het volgende geschreven:

> If I read this, this req says: “do stateful dhcpv6 (ia_pd) in case of M-flag=1 OR O-flag=1 in the received RA”.
> Right or not ???

Right, although 'out-of-scope' doesn't mean 'don't try IA_PD'. I personally wouldn't have tied IA_PD to the M or O flag at all: a CPE cannot properly work without IA_PD so I see no reason to not use it always. WPD-4 seems overly restrictive to me (wish I spotted that before, bit late now). I would have preferred it to just read: "the IPv6 CE router MUST always initiate DHCPv6 prefix delegation", although this is still possible even with the current wording.

> If this statement is correct, I’m totally lost.  According to what I read in RFC4861 and 3315.  O=1 means “other configuration” means “information-request” DHCPv6 messages i.s.o. solicit, meaning not (allowed) to add stateful options (IA_INA/IA_PD options) ???

The M and O flag are indications. It is not forbidden to have a stateful DHCPv6 server on the LAN even if you don't advertise it with the M flag.

> “”
> “”

Not necessarily. I have seen lots of networks that offer IA_PD on such a network.

> Hosts use router advertisements for non-link-local addresses and other methods (such as manual configuration) to configure other settings.

That is more dependent on the A(utoconf) flag in the prefix options. It is possible to configure a network to use both DHCPv6 IA_NA and Autoconf at the same time. Manual configuration is always possible of course.

> This combination is known as DHCPv6 stateful, in which DHCPv6 is assigning stateful addresses to IPv6 hosts.

The way you write it sounds too strict to me. M=1 means that IA_NA addresses could be obtained from a stateful DHCPv6 server. It doesn't exclude other ways of configuration (autoconf, manual).

> The M Flag is Set to 0 and the O Flag is Set to 1. DHCPv6 is not used to assign addresses, only to assign other configuration settings.

Ack

> Neighboring routers are configured to advertise non-link-local address prefixes from which IPv6 hosts derive stateless addresses.

That is the A flag in the prefix option again. It doesn't have to be set, but if it isn't set in any of the prefixes then manual configuration is required.

> This combination is known as

That is the most common way to do it yes.

> The M Flag is Set to 1 and the O Flag is Set to 0. In this combination, DHCPv6 is used for address configuration but not for other settings. Because IPv6 hosts typically need to be configured with…

If the M flag is set the O flag doesn't really have a meaning anymore as far as I know.

Cheers,
Sander

---

From: Ole Troan <[email-masked]>
Date: Tue, 10 Dec 2013 15:54:31 +0100

Carl,

I agree with you. I believe the WPD-4 in RFC6204 is correct and not the one in RFC7084.

cheers,
Ole

> Although I did not plan to send another mail on these reqs, I’ve got a question on the below, as I’m fully lost now I’m afraid.
>  
> _______________________________________________
> v6ops mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/v6ops

---

From: Ted Lemon <[email-masked]>
Date: Tue, 10 Dec 2013 11:56:36 -0500

> If this statement is correct, I’m totally lost.  According to what I read in RFC4861 and 3315.  O=1 means “other configuration” means “information-request” DHCPv6 messages i.s.o. solicit, meaning n…

The statement is there as a compromise, which was discussed at length in the working group, resulting from a lack of agreement on what the 'O' bit means.   It needs to be there, and is correct.   It really doesn't make any sense for an HG _not_ to do prefix delegation.